<template>
    <div id="app">
        <transition name="changePage" mode="out-in">
            <router-view></router-view>
        </transition>
    </div>
</template>

<script>


    export default {
        mounted() {
            this.initNiceText();
            window.addEventListener('resize', this.initNiceText);
        },
        name: 'app',
        methods: {
            mouseEnterFunc (bg) {
                bg.style.transition = 'all 0.6s ease-out';
                setTimeout(()=>{
                    bg.style.transition = 'all 0.2s';
                }, 800)
            },
            mouseMoveFunc (corner, center, e, bg, elem, coords, direction) {
                corner = (center - (e.pageY - coords.top))/center * 90;
                if (direction === 'toRight') {
                    bg.style.width = (e.pageX - coords.left)/elem.offsetWidth * 100 +"%";
                    if (corner > 0) {
                        bg.style.clipPath = `polygon(0% 100%, 0% 0%, ${100 - corner}% 0%, 100% 100%)`
                    }
                    else {
                        bg.style.clipPath = `polygon(0% 100%, 0% 0%, 100% 0%, ${100 + corner}% 100%)`
                    }
                }
                else {
                    bg.style.width = -(e.pageX - coords.right)/elem.offsetWidth * 100 +"%";
                    if (corner > 0) {
                        bg.style.clipPath = `polygon(${100 - corner}% 100%, 0% 0%, 100% 0%, 100% 100%)`
                    }
                    else {
                        bg.style.clipPath = `polygon(0% 100%, ${ - corner}% 0%, 100% 0%, 100% 100%)`
                    }
                }
            },
            leaveMouseFunc (bg) {
                bg.style.transition = 'all 1s';
                bg.style.width = 0 +"%";
                setTimeout(()=>{
                    bg.style.transition = 'all 0s';
                }, 1000)
            },
            getCoords (elem) {
                let box = elem.getBoundingClientRect();
                return {
                    top: box.top + pageYOffset,
                    left: box.left + pageXOffset,
                    right: box.right + pageXOffset,
                    bottom: box.bottom + pageYOffset
                }
            },
            initNiceText() {
                let elem = document.getElementsByClassName("nice_text");
                let bg = document.getElementsByClassName("nice_text-bg");
                let language = this.$i18n.locale;
                let animationDirection = '';

                if (language === 'en' || language === 'ru') animationDirection = 'toRight';
                    else animationDirection = 'toLeft';

                for (let i = 0; i < elem.length; i++) {
                    let coords = this.getCoords(elem[i]);
                    let center = elem[i].offsetHeight/2;
                    let corner;

                    bg[i].style.clipPath = `polygon(0% 100%, 0% 0%, 100% 0%, 100% 100%)`;

                    elem[i].addEventListener("mouseenter", ()=>{
                        this.mouseEnterFunc(bg[i])
                    });
                    elem[i].addEventListener("mousemove", (e)=>{
                        this.mouseMoveFunc(corner, center, e, bg[i], elem[i], coords, animationDirection)
                    });
                    elem[i].addEventListener("mouseleave", ()=>{
                        this.leaveMouseFunc(bg[i]);
                    })
                }
            }
        },
        watch:{
            $route (){
                setTimeout(()=>{
                    this.initNiceText();
                }, 600)
            },
            $locale() {
                this.initNiceText();
            }
        }
    }
</script>

<style lang="sass">
    .changePage-enter
        opacity: 0
    .changePage-enter-active
        transition: all 0.5s
    .changePage-leave-active
        opacity: 0
        transition: all 0.5s
</style>
